﻿using System.Collections.Generic;
using System.IO;
using System.Linq;

namespace PRMaterials
{
    /// <summary>Writes con files</summary>
    public static class ConWriter
    {
        /// <summary>
        /// Writes materials to a con file
        /// </summary>
        /// <param name="cells">Cells to write</param>
        /// <param name="conWriter">Writer to write con file</param>
        public static void WriteCells(IEnumerable<KeyValuePair<CellKey, Cell>> cells, TextWriter conWriter)
        {
            WriteGenerationHeader(conWriter);

            conWriter.WriteLine("Run ImpactSounds.con");
            conWriter.WriteLine("Run MaterialManagerdefine.con");
            conWriter.WriteLine();

            foreach (var (key, cell) in cells.OrderBy( x => x.Key ))
            {
                conWriter.WriteLine($"MaterialManager.createCell {key.Attacker} {key.Defender}");
                cell.WriteToCon( conWriter );
            }
        }


        /// <summary>
        /// Writes materials to a con file
        /// </summary>
        /// <param name="materials">Materials to write</param>
        /// <param name="conWriter">Writer to write con file</param>
        public static void WriteMaterials(IEnumerable<Material> materials, TextWriter conWriter)
        {
            WriteGenerationHeader(conWriter);

            foreach (var material in materials.OrderBy( x => x.Id )) {
                material.WriteToCon( conWriter );
                conWriter.WriteLine();
            }
        }

        /// <summary>
        /// Writes header to inform that files are generated
        /// </summary>
        /// <param name="conWriter"></param>
        private static void WriteGenerationHeader(TextWriter conWriter)
        {
            conWriter.WriteLine("rem *******************************************************************");
            conWriter.WriteLine("rem =====================!!! DO NOT EDIT !!!===========================");
            conWriter.WriteLine("rem This file got generated by PRMaterials and must not be edit by hand");
            conWriter.WriteLine("rem *******************************************************************");
            conWriter.WriteLine();
        }
    }
}
